﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        //Инициализация bitmap и графики
        Bitmap bmp;
        Graphics g;
        Point p1 = Point.Empty;
        Point p2 = Point.Empty;
        
        int y = 20;
        bool k = false;//отвечает за цвет заливки выпадающего круга
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            timer1.Start();//вызываем функцию таймера
        }

        private void mydraw(int y, bool key)
        {
            //Создаем объекты для закрашивания фигур
        SolidBrush black = new SolidBrush(Color.Black);
        SolidBrush white = new SolidBrush(Color.White);
        SolidBrush gray = new SolidBrush(Color.Gray);
        Size s = Size.Empty;//размер круга

        //Создаем bitmap и графику из bitmap
            bmp = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            g = Graphics.FromImage(bmp);
            //инициализация переменных
            s.Width = 200;
            s.Height = 200;
            p1.X = pictureBox1.Width / 2 - s.Width / 2;
            p1.Y = 20;
            p2.X = p1.X;
            p2.Y = p1.Y + 350;
            //заливка фона
            g.FillRectangle(gray, 0, 0, pictureBox1.Width, pictureBox1.Height);
            
            //рисование фигур
            if (key)
            {
                g.FillEllipse(white, p1.X, p1.Y, s.Width, s.Height);
                g.FillEllipse(white, p2.X, p2.Y, s.Width, s.Height);
                g.FillEllipse(black, p1.X, y, s.Width, s.Height);//падающий круг
            }
            else
            {
                g.FillEllipse(black, p1.X, p1.Y, s.Width, s.Height);
                g.FillEllipse(black, p2.X, p2.Y, s.Width, s.Height);
                g.FillEllipse(white, p1.X, y, s.Width, s.Height);//падающий круг
            }
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {
        }

        private void timer1_Tick(object sender, EventArgs e)
        {

            y++;//падение круга
            if (y == p2.Y) { 
                y = p1.Y;//возвращение на исходную позицию
                //изменение параметра
                if (k) k = false;
                else k = true;
            }
            mydraw(y,k);// вызов прорисовки
            pictureBox1.Image = bmp;//отображаем bitmap на PictureBox
        }
    }
}
